Bug 126863 - CAN-2004-0493 folding header DoS
CAN-2004-0493 folding header DoS
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 3
Classification: Red Hat
Component: httpd (Show other bugs)
3.0
All Linux
medium Severity medium
: ---
: ---
Assigned To: Joe Orton
: Security
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2004-06-28 11:20 EDT by Mark J. Cox (Product Security)
Modified: 2007-11-30 17:07 EST (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2004-07-06 04:34:33 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Mark J. Cox (Product Security) 2004-06-28 11:20:03 EDT
Apache 2.0.49 places no limit on the amount of folding of input
headers, or in the total length after folding.  With an input stream
with infinite headers to be folded, the server will allocate as much
memory as the system will allow, possibly leading to a denial of
service.  

Public by Georgi Guninski to full-disclosure on Jun28

        CAN-2004-0493 Affects: 3AS 3WS 3ES 3Desktop
Comment 1 Jacek Piskozub 2004-06-30 01:48:41 EDT
The original report by Guninski is to be found at
http://www.guninski.com/httpd1.html
Comment 2 Neil Horman 2004-07-01 10:48:50 EDT
Quick thought for a workaround while this gets straigtened out:

Use ulimit -d to limit the amount of data memory that any one httpd
process can have. Make it high enough to function for whatever purpose
you use httpd for, but lower than all of memory (i.e. unlimited)

I can recall if allocations above 'ulimit -d' core out the process or
return ENOMEM, but if they do the former, enable core files, and write
a cron job to clean up and restart any crashed httpd processes.  This
should prevent significant system slow down, and allow for a modest
prevention of the DoS attack.
Comment 3 Mark J. Cox (Product Security) 2004-07-06 04:34:34 EDT
An errata has been issued which should help the problem 
described in this bug report. This report is therefore being 
closed with a resolution of ERRATA. For more information
on the solution and/or where to find the updated files, 
please follow the link below. You may reopen this bug report 
if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2004-342.html

Note You need to log in before you can comment on or make changes to this bug.